/**
 * Created by Shovkoplias on 16.10.2015.
 */
import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;

public class Check implements Checker {

    int n;
    int a[];


    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        n = inf.nextInt();
        a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = inf.nextInt();
        }
        int jAns = ans.nextInt();
        int cAns = ouf.nextInt();
        int bad = 0;
        for (int i = 0; i < n; i++) {
            int cur = ouf.nextInt() - 1;
            if (cur < 0 || cur >= n || a[cur] == 0) {
                return new Outcome(Outcome.Type.WA,
                    String.format("Incorrect %d number of sertificate", i + 1));
            }
            if (isBad(cur)) {
                bad++;
            }
            a[cur] = 0;
            /*for (int j = 0; j < n; j++) {
            /    System.err.print(a[j] + " ");
            }
            System.err.println(); */
        }
        if (bad != cAns) {
            return new Outcome(Outcome.Type.WA,
                    String.format("Contestant answer: %d, but sertificate say that %d", cAns, bad));
        }

        if (cAns < jAns) {
            return new Outcome(Outcome.Type.FAIL,
                    String.format("Contestant answer: %d less than jury's: %d", cAns, jAns));
        }

        if (cAns > jAns) {
            return new Outcome(Outcome.Type.WA,
                    String.format("Contestant answer: %d worse than jury's: %d", cAns, jAns));
        }

        return new Outcome(Outcome.Type.OK, String.format("%d", cAns));
    }



    private boolean isBad(int i) {
        return a[i] <= prev(i) || a[i] <= next(i);
    }

    private int prev(int i) {
        return i == 0 ? 0 : a[i - 1];
    }

    private int next(int i) {
        return i == n - 1 ? 0 : a[i + 1];
    }

}
