import random
import os
import shutil
import math

if os.path.exists('../tests'):
    print('Directory "tests" already exists')
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)

try:
    os.makedirs('../tests')
except OSError:
    pass


random.seed(239)

test_number = 1

def write_test(l, v, arr1, arr2):
    global test_number
    name = "0" * (2 - len(str(test_number))) + str(test_number)

    outp = open("../tests/" + name, "w")

    outp.write(str(len(arr1)) + " " + str(len(arr2)) + " " + str(l) + " " + str(v) + "\n")

    outp.write(" ".join(map(str, arr1)) + "\n")

    for i in range(len(arr2)):
        if (arr2[i][0] == 0):
            outp.write("- " + str(arr2[i][1]) + "\n")
        else:
            outp.write("+ " + str(arr2[i][1]) + "\n")

    print("Test #" + str(test_number) + " has been generated")
    test_number += 1
    outp.close()
    


write_test(100, 3, [5, 25, 75], [[0, 5], [1, 90], [1, 37], [0, 75]])

maxn = 100000

def gen1():
    l = random.randint(3, 1000)
    n = random.randint(0, l)
    m = maxn
    v = random.randint(1, 1000)

    order = [i for i in range(l)]

    random.shuffle(order)

    arr1 = order[:n]
    
    c = n
    cond = 1
    arr2 = []
    for i in range(m):
        if (cond == 1 and c == l):
            random.shuffle(order)
            c = 0
            cond = -1
        if (cond == -1 and c == l):
            random.shuffle(order)
            c = 0            
            cond = 1
        
        if (cond == 1):
            arr2.append([1, order[c]])
        else:
            arr2.append([0, order[c]])
        c += 1

    write_test(l, v, arr1, arr2)

for i in range(5):
    gen1()

maxl = 10 ** 9
write_test(maxl, 1, [0], [[1, maxl // 2], [1, maxl // 2 + 1]])

def gen_big_test():
    l = maxl
    n = maxn
    m = maxn
    v = random.randint(1, 10)

    s = set()

    arr1 = []
    arr2 = []
    for i in range(n):
        tmp = random.randint(0, l - 1)
        while (tmp in s):
            tmp = random.randint(0, l - 1)
        arr1.append(tmp)
        s.add(tmp)

    for i in range(m):
        #if (i % 100 == 0):
        #    print(i)
        act = random.randint(0, 1)
        if (len(s) == 0):
            act = 1
        
        if (act == 1):
            tmp = random.randint(0, l - 1)
            while (tmp in s):
                tmp = random.randint(0, l - 1)
            arr2.append([1, tmp])
            s.add(tmp)
        else:
            #tmp = random.sample(s, 1)[0]
            tmp = next(iter(s))
            s.remove(tmp)

            arr2.append([0, tmp])
    write_test(l, v, arr1, arr2)
    #print("!")


for i in range(3):
    gen_big_test()


def gen2(base):
    l = maxl
    n = 0
    m = maxn
    v = random.randint(1, 10)

    arr1 = []
    arr2 = []

    c = 0
    bd = int(math.log(l, base))
    
    for i in range(bd, -1, -1):
        bdv = base ** i
        for j in range(0, l, bdv):
            if (j % bdv == 0 and j % (bdv * base) != 0):
                arr2.append([1, j])
                c += 1
                if (c == m):
                    break
        if (c == m):
            break
    write_test(l, v, arr1, arr2)    

for i in range(2, 5):
    gen2(i)
    
def gen3(base):
    l = maxl
    n = 0
    m = maxn
    v = random.randint(1, 10)

    arr1 = []
    arr2 = []

    c = 0
    bd = int(math.log(l, base))
    
    for i in range(bd, -1, -1):
        bdv = base ** i
        nowarr = []
        for j in range(0, l, bdv):
            if (j % bdv == 0):
                arr2.append([1, j])
                nowarr.append(j)
                c += 1
                if (c == m):
                    break
        if (c == m):
            break
        for num in nowarr:
            arr2.append([0, num])
            c += 1
            if (c == m):
                break
        if (c == m):
            break
    write_test(l, v, arr1, arr2)    


for i in range(2, 5):
    gen3(i)